/*
 * _74HC165.c
*/ 

#include <avr/io.h>
#include "_74HC165.h"

// Initialisieren
void init_74HC165()
{
	HC74_165_DDR |= ( (1<<CLK) | (1<<PL) );
	HC74_165_PORT |= ( 1 << CLK);
}


// Alle Pinzustnde per Software abfragen
// Wird in HC165_Data[] gespeichert
void read_All_74HC165()
{
	// Parallel laden
	HC74_165_PORT &=~ ( 1 << PL);
	HC74_165_PORT |= ( 1 << PL);
	
	// einzelne bitseinlesen
	for (int bit = ( 8 * anzahl_74HC165 -1); bit > -1; bit--)
	{
		
		if ( ( HC74_165_PIN & ( 1 << DIN) ) )
		  HC165_Data[bit] = 1;
		else HC165_Data[bit] = 0;
		
		// Daten schieben	
		HC74_165_PORT &=~ ( 1 << CLK);
		HC74_165_PORT |= (1 << CLK);
	}
	
}

// Bestimmte Position (bitNummer) abfragen
// Nummerierung von 0 bis n
char read_Bit_74HC165(int8_t bitNummer )
{
	char temp_bit = 0;
	
	// Parallel laden
	HC74_165_PORT &=~ ( 1 << PL);
	HC74_165_PORT |= ( 1 << PL);
	
	// einzelne bytes einlesen
	for (int bit = ( 8 * anzahl_74HC165 -1); bit > (bitNummer - 1) ; bit--)
	{
		
		if ( ( HC74_165_PIN & ( 1 << DIN) ) )
		  temp_bit = 1;
		else temp_bit = 0;
		
		// Daten schieben
		HC74_165_PORT &=~ ( 1 << CLK);
		HC74_165_PORT |= (1 << CLK);
	}
	
	return temp_bit;
}