/*
 * Sparrow_Schieberegister_74HC595.c
 
 Fr diesen Code wurden zwei kaskadierte 74HC595 verwendet.
 Die Pinbelegung am M ist frei whlbar, einzustellen in _74HC595.h.
 Die Anzahl der Schieberegister ( #define anzahl_Schieberegister x) werden ebenfalls in der _74HC595.h eingestellt.
 
 Pinbelegung Sparrow : 
 Pin 11 SCK	>	PB3 2
 Pin 12 RCK	>	PB4 3
 Pin 14 SER	>	PB1 6
 Kaskade		// Pin  9 QH	>	Pin 14 SER
 
 An den Ausgngen wurden zum Testen LED's (2mA) angeschlossen. ( maximal 70mA pro Schieberegister! )
 
 Lektre zum Thema Schieberegister :
 http://www.mikrocontroller.net/articles/AVR-Tutorial:_Schieberegister
 
 */ 

#ifndef F_CPU
#define F_CPU 1200000UL
#endif

#include <avr/io.h>
#include <util/delay.h>
#include "_74HC595.h"

int main(void)
{
	init_74HC595();
	
	int test = 3;
	
	_delay_ms(1000);
    while(1)
	{
		
		// Taster 1 und Taster 2 
		// Lauflicht bis Taster 1 und Taster 2 erneut bettigt wird
		if ( (!( PINB & (1 << PB0))) && (!( PINB & (1 << PB2))) )
		{
			do 
			{			
				//Lauflicht zwei Schieberegister
				for ( int regeins = 0; regeins < 8; regeins++)
				{
					shift_Data_74HC595(HC595_Data[1]);
					shift_Data_74HC595(HC595_Data[0] = (1 << regeins));
					assume_Data_74HC595();
					_delay_ms(100);
					if (regeins == 7)
					{
						HC595_Data[0] = 0x00;
						for ( int regzwei = 0; regzwei < 8; regzwei++)
						{
							shift_Data_74HC595(HC595_Data[1] = (1 << regzwei));
							shift_Data_74HC595(HC595_Data[0]);
							assume_Data_74HC595();
							_delay_ms(100);
						}
						HC595_Data[1] = 0x00;
					}
				}
			} while ( ( PINB & (1 << PB0)) && ( PINB & (1 << PB2)) );

		}
		
		//Taster 1 
		//SchiebeRegister 0 Pin von 0 -7 setzen
		//SchiebeRegister 1 Pinausgabe Binr
		if ( !( PINB & (1 << PB0) ) )
		{
			set_Pin_74HC595(0,test); // einzelnen Pin setzen
			set_Pins_74HC595(1,test+1); // mehrere Pins setzen
			_delay_ms(500);
			test++;
		}
		
		//Taster 2
		//SchiebeRegister 0 Pin von 0 -7 lschen
		//SchiebeRegister 1 Pinausgabe Binr
		if ( !( PINB & (1 << PB2) ) )
		{
			test--;
			clear_Pin_74HC595(0,test); // einzelnen Pin setzen
			clear_Pins_74HC595(1,test); // mehrere Pins setzen
			_delay_ms(500);
		}
    }
}