/*
 * _74HC595.h
 */ 

#ifndef _74HC595_H_
#define _74HC595_H_

#define HC74_595_DDR DDRB
#define HC74_595_PORT PORTB
//#define SCL 	// Pin 10 SCL	>	PBx x oder Vcc
#define SCK 3	// Pin 11 SCK	>	PB3 2
#define RCK 0	// Pin 12 RCK	>	PB0 5
#define SIN 1	// Pin 14 SER	>	PB1 6
//Kaskade		// Pin  9 QH	>	Pin 14 SER

#define anzahl_74HC595 1
uint8_t HC595_Data[anzahl_74HC595];

void init_74HC595();

// Softwareansteuerung Schieberegister
// Daten werden in das Schieberegister geschoben
void shift_Data_74HC595(uint8_t pins);

// Daten im Schieberegister bernemen
void assume_Data_74HC595();

// einzelnen Pin setzen oder lschen,
// s_Register_Nummer	- Nummer des Schieberegisters, von 0 bis x
// s_Pin				- Nummer des zu ndernden Pin, von 0 bis 7
void set_Pin_74HC595(uint8_t s_Register_Nummer, uint8_t s_Pin);
void clear_Pin_74HC595(uint8_t s_Register_Nummer, uint8_t s_Pin);

// kompletten "Port" setzen oder lschen,
// s_Register_Nummer	- Nummer des Schieberegisters, von 0 bis x
// s_Pin				- Pinmuster ( s_Pin 5 -> Pin 0,2 aktiv s_Pin 42 -> Pin 1,3,5 aktiv ...)
void set_Pins_74HC595(uint8_t s_Register_Nummer, uint8_t s_Pins);
void clear_Pins_74HC595(uint8_t s_Register_Nummer, uint8_t s_Pins);

#endif /* _74HC595_H_ */